%define release_tag 0
%define release_stamp 202405.4.gf6e4865

Name: mcom03-linux-utils
Version: %release_tag
Release: %release_stamp.elv.alt1

Summary: Equipment testing
Group: Development/Tools
License: BSD-2-Clause
Vendor: RnD Center "ELVEES", JSC
Source: %name-%release_stamp.tar.gz
BuildArch: noarch

BuildRequires(pre): rpm-macros-cmake rpm-build-python3
BuildRequires: cmake

Requires: aplay
Requires: devmem
Requires: mpv
Requires(pre): u-boot-tools

%description
Equipment testing


%package -n mcom03-set-hostname
Summary: systemd-service for hostname generation
Group: Development/Tools

%description -n mcom03-set-hostname


%package felix
Summary: Video sensor test tool
Group: Development/Tools

Requires: felix-priv

%description felix


%package gst
Summary: GStreamer OMX test tool
Group: Development/Tools

Requires: gst-omx gstreamer1.0-utils

%description gst


%package stress-test
Summary: Stress test
Group: Development/Tools

Requires: memtester-simple
Requires: python-parallel-test

%description stress-test


%package ngfw
Summary: NGFW-specific tools
Group: Development/Tools

%description ngfw


%package test
Summary: test-specific tools
Group: Development/Tools

Requires: fio
Requires: ifmetric
Requires: iperf3
Requires: mpmflops
Requires: mtd-utils
Requires: pyfdt
Requires: ramspeed
Requires: stress-ng
Requires: sysstat
Requires: mcom03-linux-utils
Requires: mcom03-linux-utils-felix
Requires: mcom03-linux-utils-gst
Requires: mcom03-linux-utils-stress-test

%description test


%package -n mcom03-udev-rules
Summary: udev rules for mcom03
Group: Development/Tools
BuildArch: noarch

%description -n mcom03-udev-rules

%prep
%setup -n %name

%build
%cmake -DSET_HOSTNAME=ON
%cmake_build

%install
%cmake_install
mv -f %buildroot%_prefix/lib %buildroot/lib
install mcom03-get-clocks.py %buildroot%_bindir/
install mcom03-ngfw-cp-test.py %buildroot%_bindir/

install -d %buildroot%_sysconfdir/udev/rules.d
cat > %buildroot%_sysconfdir/udev/rules.d/50-mcom03.rules << EOF
SUBSYSTEM=="elcore50", MODE="0660", GROUP="elcore"

KERNEL=="mv500", SUBSYSTEM=="mv500", MODE="0660", GROUP="vpu"

KERNEL=="dmabuf", SUBSYSTEM=="misc", MODE="0660", GROUP="camera"
KERNEL=="gpiochip*", SUBSYSTEM=="gpio", MODE="0660", GROUP="camera"
KERNEL=="i2c-*", SUBSYSTEM=="i2c-dev", MODE="0660", GROUP="camera"
KERNEL=="imgfelix*", SUBSYSTEM=="misc", MODE="0660", GROUP="camera"
KERNEL=="sensor_phy*", SUBSYSTEM=="elvees,mcom03-dw-mipi-dphy", MODE="0660", GROUP="camera"
EOF

%files
%_bindir/mcom03-demo-audio.sh
%_bindir/mcom03-demo-video.sh
%_bindir/mcom03-get-clocks.py
%_bindir/mcom03-get-power-device-property.sh
%_bindir/mcom03-leds-blink
%_bindir/mcom03-pwm-ctrl.sh
%_bindir/mcom03-display-switch.sh
%_sbindir/mcom03-hdmi-setup.sh
%_sbindir/mcom03-pixclk-pll-restart.sh
%_datadir/pixmaps/gradient.png
%_sysconfdir/udev/rules.d/10-persistent-mtd.rules

%define start_tag # START %name-%version-%release
%define end_tag # END %name-%version-%release
%define fw_conf /etc/fw_env.config

%pre
if ! grep -qF "%start_tag" %fw_conf; then
    cat >>%fw_conf <<EOF
%start_tag
# This file for MCom-03 based boards. In case multiple MTD devices
# exist (e.g SPI and NAND) in the system order of driver initialization and
# hence MTD devices names are inconsistent and can vary from boot to boot.
# Its upon distribution to guarantee consistent SPI device name e.g using udev
# rules.

# This file contains the description of U-Boot environment location in SPI NOR Flash.

# MTD device name		Device offset	Env. size	Flash sector size	Number of sectors
/dev/mtd/by-name/spi0.0		0xFE0000	0x10000		0x10000
%end_tag
EOF
fi

%postun
sed -e '/%start_tag/,/%end_tag/d' -i %fw_conf

%pre -n mcom03-udev-rules
getent group elcore > /dev/null || %{_sbindir}/groupadd -r elcore
getent group vpu > /dev/null || %{_sbindir}/groupadd -r vpu
getent group camera > /dev/null || %{_sbindir}/groupadd -r camera
exit 0

%files felix
%_bindir/mcom03-csi-hdmi.sh

%files gst
%_bindir/mcom03-gst-video.sh
%_bindir/mcom03-vpu-stress.sh

%files stress-test
/lib/systemd/system-preset/40-elvees.preset
/lib/systemd/system/mcom03-stress-test.service
%_sbindir/mcom03-stress-test.sh

%files -n mcom03-set-hostname
%_sbindir/mcom03-set-hostname.sh
%_unitdir/mcom03-set-hostname.service

%files ngfw
%_bindir/mcom03-ngfw-cp-test.py

%files test

%post test
# Shell script from this section executed after installation.
#echo "mcom03-linux-utils post-install"

%preun test
# Shell script from this section executed before uninstallation.
#echo "mcom03-linux-utils pre-uninstall"

%files -n mcom03-udev-rules
%_sysconfdir/udev/rules.d/50-mcom03.rules
